function [ u_t ] = z_lucy( img, filter, numiter )

si = size (img);
sf = size (filter);

%filter = padarray(filter, ceil((si-sf)/2), 0, 'post');
%filter = padarray(filter, floor((si-sf)/2), 0, 'pre');

rotfilter = filter (end:-1:1,end:-1:1);

u_t = ones(si); 

for ii = 1:numiter
    conres = conv2(u_t, filter, 'same');
    conres(conres == 0) = eps;
    u_t = u_t.*(conv2(img./conres, rotfilter,'same'));
end

end
