clear
clc
close all

img = double(rgb2gray(imread('sentetik.png')))/255;

filter = z_createFilter('gaussian', 3, 10);
blurred = conv2(img, filter, 'same');


f_k = ones(size(blurred));

f_k = blurred;
numIterK = 100;

for kk = 1:numIterK
    g_k = z_lucy(blurred, f_k,40);
    g_k(g_k > 1) = 1;
    g_k(g_k < 0) = 0;
    f_k = z_lucy(blurred, g_k,40);
    f_k(f_k > 1) = 1;
    f_k(f_k < 0) = 0;
end
imshow(blurred);
figure;
imshow(f_k, []);
figure;
imshow(g_k, []);
figure;
imshow(conv2(f_k, g_k, 'same'),[]);